diff --git a/benchtests/Makefile b/benchtests/Makefile
index 25dfe700a6..bb21721057 100644
--- a/benchtests/Makefile
+++ b/benchtests/Makefile
@@ -48,6 +48,7 @@ bench-math := \
   exp2m1f \
   expf \
   expm1 \
+  expm1f \
   floor \
   floorf \
   fmax \
diff --git a/benchtests/expm1f-inputs b/benchtests/expm1f-inputs
new file mode 100644
index 0000000000..6b80475401
--- /dev/null
+++ b/benchtests/expm1f-inputs
@@ -0,0 +1,799 @@
+## args: float
+## ret: float
+## includes: math.h
+## name: workload-random
+# Random inputs in [a=-14.495465,b=88.722832]
+# where a is the smallest number such that expm1f does not round to -1
+# and b is the smallest number such that expm1 rounds to +Inf (to nearest)
+0x1.3810cp+6
+0x1.d5f38p+3
+0x1.5bbafp+4
+0x1.274218p+5
+-0x1.4e6a94p+2
+-0x1.898c1ap-1
+0x1.609cf8p+5
+0x1.9cc3a4p+4
+0x1.2df7eep+4
+0x1.73defep+5
+0x1.dd4ddap+3
+-0x1.9fe548p+3
+0x1.b3c8f2p+1
+0x1.3ac27cp+6
+0x1.b43346p+5
+0x1.1e7d4ep+2
+0x1.a65c52p+5
+0x1.3c2c3ap+5
+0x1.0ae18ep+6
+0x1.5d1cccp+6
+0x1.5e376ep+6
+0x1.46e41ap+5
+0x1.58bd84p+0
+-0x1.ad6876p+3
+0x1.ac642ep+4
+0x1.45482ep+2
+0x1.6a3fe6p+1
+0x1.b1da94p+3
+0x1.0bac6ep+6
+0x1.b7f212p+5
+0x1.4c9a62p+6
+0x1.903de4p+5
+0x1.0021e8p+4
+0x1.17b81p+3
+0x1.5cf974p+6
+0x1.1ca20ap+6
+0x1.aeb732p+5
+0x1.c60614p+5
+0x1.186b38p+6
+0x1.abbb34p+5
+0x1.5c2474p-2
+0x1.e6855cp+3
+0x1.14068cp+4
+0x1.710416p+4
+-0x1.cc704cp+2
+0x1.534bdap+6
+0x1.8b0c18p+3
+0x1.36de48p+1
+0x1.33b7f4p+5
+0x1.19c128p+5
+0x1.d9d7dap+5
+0x1.343482p+6
+0x1.c82f4ap+5
+-0x1.1123ep-1
+0x1.a66ed2p+5
+0x1.30fd8p+6
+0x1.221296p+6
+-0x1.cb7386p+1
+0x1.00cdccp+5
+-0x1.8d3f3ap+2
+-0x1.d4dbf6p+2
+0x1.fdf25ap+4
+0x1.d5fd5cp+3
+0x1.fbd1ep+4
+0x1.116b76p+6
+0x1.b9b8b4p+1
+0x1.b5dfdp+2
+0x1.c49f3cp+5
+0x1.608052p+6
+0x1.34cb2p+6
+0x1.e95b62p+3
+0x1.1984f4p+6
+0x1.f7a902p+5
+0x1.55b80ep+3
+0x1.e63ffap+3
+-0x1.acc202p+1
+0x1.2670c4p+4
+0x1.3cb908p-1
+0x1.2a3b32p+3
+0x1.ef2c8ap+5
+-0x1.86fb0ap+2
+-0x1.10ce8ap+1
+-0x1.ee4398p+2
+0x1.317bacp+6
+-0x1.7844b8p+3
+0x1.cc4ac8p+5
+0x1.56d116p+4
+-0x1.b79b38p+3
+0x1.34dcaep+5
+0x1.79f55cp+4
+0x1.6c0398p+5
+-0x1.04565cp+3
+0x1.9340ccp+2
+0x1.d8856cp+5
+-0x1.bc5034p+1
+0x1.97348cp+5
+0x1.76a472p+5
+0x1.111a1ep+5
+0x1.19bc32p+4
+0x1.5d75c2p+6
+0x1.a1dcaap+5
+0x1.079abcp+6
+0x1.8b0ca8p+5
+0x1.2e6548p+6
+0x1.24d536p+5
+0x1.3d8efcp+5
+-0x1.fa06c8p+2
+0x1.c20454p+5
+0x1.bbd65cp+3
+0x1.53db36p+6
+0x1.7f69b2p+4
+0x1.f8aab8p+4
+0x1.42f736p+5
+0x1.121742p+5
+0x1.2dc1c2p+5
+0x1.0d4e32p+5
+0x1.0a6128p+6
+0x1.afc1d6p+5
+0x1.1a29ap+6
+-0x1.c5e0c2p+3
+0x1.15b464p+6
+0x1.b1eb2ap+5
+-0x1.6f737p+0
+0x1.8c9f04p+0
+-0x1.56ad02p+3
+0x1.c595aap+5
+0x1.1c4056p+6
+0x1.45ba98p+5
+0x1.aff522p+5
+0x1.ac9542p+4
+0x1.4cc0d6p+1
+0x1.4adb2ep+6
+0x1.3491c2p+5
+0x1.559a82p+3
+0x1.def4p+5
+0x1.23f276p+5
+-0x1.d5eff8p+2
+0x1.e6ca08p+4
+0x1.f83e38p+3
+0x1.331a4p+6
+0x1.57df6cp+3
+-0x1.852c2ep+3
+0x1.bd56fcp+5
+-0x1.3720a6p+3
+0x1.3e49cp+1
+0x1.3a1e0ap+5
+0x1.7525c8p+5
+0x1.5ff3c8p+6
+0x1.5fbbd6p+6
+0x1.40f626p+5
+-0x1.87d02ep+3
+0x1.56345ep+2
+0x1.a735aep+2
+0x1.3b30bap+5
+-0x1.da7242p+2
+-0x1.9b8284p+1
+0x1.16a344p+6
+0x1.af11e4p+3
+0x1.53f7e6p+5
+0x1.50e1a8p+5
+0x1.242fe4p+6
+-0x1.18156ap+3
+-0x1.1ac67cp+2
+0x1.d53c02p+5
+0x1.5217c4p+6
+0x1.6da49ep+5
+0x1.17bfbp+6
+-0x1.0e3c48p+2
+-0x1.3b7a1ap+2
+0x1.41462cp+6
+0x1.aaee8p+4
+0x1.d2579cp+5
+-0x1.865634p+3
+0x1.a3876cp+5
+0x1.e512d8p+3
+0x1.bc6f4ep+4
+0x1.b14bfep+5
+0x1.ec787cp+4
+0x1.268bf6p+4
+-0x1.bf2e34p+2
+0x1.861576p+5
+0x1.41c256p+4
+0x1.69b71cp+5
+0x1.601c7ap+6
+0x1.b97298p+4
+0x1.82e8bp+5
+0x1.83c418p+5
+0x1.21dee6p+3
+0x1.cb17fap+5
+0x1.38c41cp+6
+-0x1.c2683cp+3
+0x1.3d6fcp+5
+0x1.d1ef44p+5
+0x1.47d6c2p+3
+0x1.380822p+6
+0x1.442deap+6
+0x1.25b0dcp+5
+0x1.03867cp+5
+0x1.8e554ep+5
+0x1.26befep+4
+-0x1.37db3ap+0
+-0x1.0508eap+3
+0x1.d25cecp+5
+0x1.05cf7cp+6
+0x1.c31c7p+5
+0x1.a86266p+5
+0x1.59e8a2p+6
+0x1.ef79ep+4
+0x1.212d2p+1
+-0x1.b8245ap+3
+0x1.30aec4p+5
+0x1.5fe628p+6
+0x1.caa0fap+5
+0x1.229bap+4
+0x1.1e5278p+6
+0x1.146544p+6
+0x1.009ecp+6
+0x1.9c90b4p+5
+0x1.0145dep+6
+0x1.6b25ap+5
+-0x1.9c2698p+1
+0x1.441204p+4
+0x1.396798p+5
+0x1.5b5dc8p+4
+0x1.27f358p+6
+0x1.79b952p+3
+0x1.1a30ecp+6
+0x1.0eb864p+6
+0x1.bd1f6ep+5
+0x1.90f39ap+4
+0x1.d00fa4p+5
+0x1.38d37ep+5
+0x1.942356p+4
+0x1.041a1ap+6
+0x1.ff196cp+3
+0x1.24bcd4p+6
+-0x1.3d97eap+3
+0x1.f6224p+5
+0x1.2cfdbep+5
+0x1.42fa36p+5
+0x1.844ce4p+5
+0x1.5810aep+6
+0x1.df2214p+5
+0x1.580ba4p+6
+0x1.620818p+3
+0x1.7e9a86p+5
+0x1.5fc452p+6
+-0x1.b0f38cp+3
+-0x1.b4c3ap+0
+0x1.ae6154p+4
+0x1.334348p+6
+0x1.daa71p+4
+0x1.9c2e0ep+5
+0x1.140af2p+5
+0x1.5dc292p+6
+0x1.f7f7e4p+5
+-0x1.d74c66p+2
+0x1.249b98p+6
+0x1.750da8p+3
+0x1.3782ccp+5
+0x1.3ad2f4p+6
+0x1.1b2256p+6
+0x1.be193p+3
+0x1.6074f2p+4
+0x1.926602p+5
+0x1.640a02p+3
+0x1.4d343p+0
+0x1.5eaabcp+4
+0x1.7e4ff4p+5
+0x1.631a3ap+4
+0x1.2bcc8p+3
+0x1.6abe2ap+5
+0x1.85e932p+5
+0x1.6ea55ap+2
+-0x1.a9a304p+2
+0x1.05ba9ep+6
+-0x1.ca222cp+2
+0x1.64940ep+5
+0x1.2ebe6cp+4
+0x1.7c91c2p+5
+0x1.f0368ap+4
+-0x1.129f02p+1
+0x1.7ed0a4p+4
+0x1.11beb2p+6
+0x1.330d7ap+4
+0x1.3bc6eep-1
+0x1.02348p+6
+0x1.35064ap+5
+0x1.3c44p+5
+0x1.c128eep+5
+0x1.837444p+3
+0x1.9116dap+5
+-0x1.7fb6f2p+3
+0x1.d74884p+4
+-0x1.dd8e86p+2
+0x1.db84e2p+5
+-0x1.9aa036p+2
+0x1.a108cep+5
+0x1.60ed52p+4
+0x1.c738eap+5
+0x1.1d9b9p+1
+0x1.5542ep+6
+0x1.074218p+0
+0x1.16afeep+6
+0x1.31b3dp+5
+0x1.8127a8p+5
+0x1.27d12p+2
+0x1.962ad2p+3
+0x1.726aacp+2
+0x1.e9e8bap+5
+0x1.b54284p+5
+0x1.acb4fcp+5
+0x1.2a671p+6
+0x1.de6a98p+5
+0x1.6a2454p+2
+0x1.85b1b8p+5
+0x1.a50b94p+5
+0x1.77bfaep+2
+0x1.41c6ap+3
+0x1.e51cdep+5
+0x1.4de72cp+6
+0x1.413186p+6
+-0x1.bbc70ap+3
+-0x1.f138fcp+2
+0x1.78855p+5
+0x1.dd16bep+4
+0x1.2c491p+2
+0x1.500ff6p+6
+-0x1.035c0ep+2
+0x1.3a7688p+5
+0x1.82bb26p+5
+0x1.0c41d2p+6
+-0x1.85128cp+1
+0x1.54a6f8p+5
+0x1.66e21cp+5
+0x1.d3cce6p+1
+0x1.a16cbap+3
+-0x1.096126p+2
+-0x1.a45e04p+3
+0x1.7d697p+5
+0x1.106d1ap+6
+0x1.04e974p+4
+0x1.6ce8b4p+3
+0x1.8b3bd4p+3
+0x1.7db442p+4
+0x1.3c3318p+6
+0x1.91a55ep+4
+0x1.378ffap+6
+-0x1.5f7422p+2
+0x1.6c9034p+3
+-0x1.f8ff9ep+1
+0x1.d2f0dp+4
+0x1.4e15dcp+6
+-0x1.a41644p+2
+0x1.1074f4p+5
+0x1.c08daap+5
+0x1.0a83a2p+3
+-0x1.e24802p+1
+0x1.54555cp+6
+0x1.b6cac8p+5
+-0x1.3f30dap+1
+0x1.c9d7e6p+4
+0x1.054b78p+6
+0x1.9a9d3cp+5
+0x1.eaea98p+5
+0x1.e6dcd2p+4
+0x1.4c5e9ap+2
+0x1.990a46p+3
+0x1.5b856p+5
+0x1.53b10cp+6
+0x1.3085b8p+2
+0x1.33623ap+6
+0x1.79211cp+2
+0x1.487144p+6
+0x1.8540c4p+5
+0x1.7d81eep+4
+0x1.c2663ep+5
+0x1.177a4ep+6
+0x1.9d505cp+5
+0x1.656852p+4
+-0x1.cc7e2cp+1
+0x1.a8057ap+4
+0x1.86fd48p+3
+-0x1.148908p+1
+0x1.5bc9fep+2
+0x1.4cd724p+5
+0x1.5cff22p+6
+-0x1.aaecc8p+2
+0x1.14cb74p+5
+0x1.ce6106p+4
+0x1.51cda4p+4
+0x1.171dbp+6
+0x1.4a3d88p+1
+0x1.1bd39ep+6
+0x1.7a88a4p+5
+0x1.7a31e4p+4
+0x1.1b585cp+6
+0x1.528cc6p+5
+0x1.a58ccep+4
+0x1.c26ed8p+4
+0x1.22021cp+6
+0x1.1b8a9p+6
+0x1.e2c44p+5
+0x1.fe1bb4p+5
+0x1.0548acp+6
+0x1.12ce22p+6
+0x1.623584p+6
+0x1.7a0d8p+5
+0x1.9b770ep+3
+0x1.3c827ap+4
+0x1.54d708p+4
+0x1.114dc6p+6
+0x1.a34a9ap+4
+-0x1.85b6bcp+3
+0x1.cba9f2p+4
+0x1.a81124p+4
+-0x1.a0265cp+3
+0x1.376a9p+5
+0x1.f878p+5
+0x1.3a403ep+6
+0x1.3b4e9cp+6
+0x1.3a7ecp+6
+0x1.0e7c34p+4
+0x1.d974ecp+3
+0x1.f96p+3
+0x1.b07262p+5
+0x1.c0761ep+5
+-0x1.8d95aap+3
+0x1.f9b2eap+2
+0x1.c45722p+3
+0x1.22035cp+3
+-0x1.14f90cp+2
+0x1.f3f58p+5
+-0x1.3f0d4p+3
+0x1.712122p+4
+0x1.6c70b4p+4
+0x1.5386p+5
+-0x1.676fcep+3
+0x1.087cdap+6
+0x1.5e31bcp+6
+0x1.59c27p+6
+0x1.8fda26p+5
+0x1.bac6dcp+5
+0x1.94bcbap+1
+0x1.b4272cp+4
+0x1.28b6e6p+4
+0x1.15d214p+5
+-0x1.258ca8p+2
+0x1.67d242p+4
+0x1.b463bep+4
+0x1.82d508p-1
+0x1.453544p+6
+0x1.59c3e2p+5
+0x1.a5444cp+0
+0x1.023312p+2
+0x1.4e49a2p+6
+0x1.3b2906p+3
+0x1.db3a42p+0
+0x1.482b3cp+4
+0x1.1b5f4p+4
+0x1.0a249ap+5
+-0x1.4d103cp+3
+-0x1.3f9a6p+1
+0x1.fb22d4p+4
+0x1.ae6726p+5
+0x1.5065c8p+5
+0x1.85a07ap+3
+0x1.08e6p+4
+0x1.9e5ddep+4
+0x1.5c2b96p+6
+0x1.025d3ep+3
+-0x1.b61288p+2
+0x1.767a9p+4
+-0x1.e1d398p+2
+0x1.61a05ap+4
+0x1.c1dcbep+4
+0x1.bc94c4p+5
+0x1.bab56ep+5
+0x1.3dd33ap+4
+0x1.57b106p+6
+-0x1.d493dcp+2
+0x1.c7c276p+5
+0x1.d177d8p+3
+0x1.e07254p+4
+0x1.e7a35ap+4
+0x1.f5361cp+3
+0x1.9124ap+5
+0x1.7cde4cp+5
+0x1.5868d6p+5
+0x1.34e748p+5
+0x1.883d3ap+5
+0x1.5a718ep+5
+0x1.416afcp+5
+0x1.b75ad8p+5
+0x1.000a84p+5
+0x1.dfbf96p+3
+0x1.caf566p+5
+0x1.47b68p+6
+0x1.179f6ep+5
+0x1.6139e6p+6
+0x1.79aba4p+4
+0x1.3314fcp+4
+-0x1.9396e4p+0
+0x1.d1f398p+5
+-0x1.4d93ecp+2
+-0x1.13ffbap+3
+0x1.43af3cp+6
+0x1.02fe76p+6
+0x1.ea2a1cp+5
+0x1.b46644p+5
+0x1.29812ap+6
+-0x1.9a4f28p+2
+0x1.33970ep+4
+0x1.22e908p+1
+0x1.5fe03ap+6
+0x1.593f74p-2
+0x1.12a9b6p+6
+0x1.d0aa12p+5
+0x1.d9bd7ap+4
+0x1.6abe46p+5
+0x1.6a7cd2p+5
+-0x1.243e06p+3
+0x1.8dc5b2p+5
+0x1.d19254p+5
+0x1.0d324p+4
+0x1.167128p+6
+0x1.667ba8p+5
+0x1.44c732p+6
+0x1.e452aep+5
+0x1.d9ad26p+5
+0x1.a6b18cp+5
+0x1.44778p+4
+0x1.6de93cp+5
+-0x1.749e0ap+3
+0x1.384234p+5
+0x1.baf766p+5
+0x1.155178p+5
+0x1.746b38p+5
+-0x1.108cf6p+3
+0x1.a42fcap+3
+0x1.e524aep+4
+0x1.70d73p+3
+0x1.10af9ap+6
+-0x1.fb00cep+1
+0x1.2084acp+6
+0x1.3ae402p+4
+0x1.3e95f2p+5
+0x1.424342p+6
+0x1.08ace2p+6
+0x1.eb0efep+5
+0x1.a4a3dap+5
+0x1.a438e8p+4
+0x1.39696ap+5
+0x1.2a706ep+6
+0x1.6fff2p+2
+0x1.ef4e3cp+5
+-0x1.20a1dp+3
+0x1.1fd284p+5
+0x1.240be4p+6
+0x1.5da7bp+4
+-0x1.49ca52p+1
+0x1.93cb38p+4
+0x1.179b56p+5
+0x1.18cf6cp+4
+0x1.d8c7cep+5
+0x1.54e87ap+6
+0x1.0556ap+6
+-0x1.f9dd92p+2
+0x1.1429eep+6
+0x1.295ef2p+5
+0x1.07eedcp+5
+0x1.58afeap+5
+0x1.e5bcc8p+2
+-0x1.a038c8p+3
+0x1.4e70a6p+6
+-0x1.172cfep-4
+0x1.355898p+3
+0x1.90292ep+5
+0x1.277aeap+4
+0x1.0e9c1cp+6
+0x1.54c948p+6
+0x1.17dc44p+2
+0x1.005c26p+3
+0x1.6c2d44p+5
+0x1.067ce8p+5
+0x1.188b3ap+1
+-0x1.c44378p+1
+0x1.16c9c4p+3
+0x1.40b782p+5
+0x1.8f8ecep+5
+0x1.aa8fbp+2
+0x1.40242ap+6
+0x1.78607cp+3
+0x1.209358p+6
+0x1.db1404p+4
+-0x1.b8ceap+1
+0x1.1e67p+6
+-0x1.c9f25ap+0
+0x1.eef1fp+5
+0x1.d17786p+4
+0x1.422a98p+6
+0x1.6efbaap+3
+0x1.5b11fep+6
+0x1.35d254p+6
+0x1.9b5daap-1
+-0x1.36c61cp+3
+0x1.5c19b4p+5
+-0x1.9dabdp+0
+0x1.b600c6p+5
+0x1.2a4238p+4
+-0x1.91e754p+2
+0x1.9740aap+4
+-0x1.77a118p+2
+0x1.125a76p+5
+0x1.08e4e2p+6
+0x1.2d6fp+4
+0x1.0046bap+4
+0x1.62c562p+6
+0x1.0d6c4p+6
+0x1.06cdbcp+6
+0x1.e88312p+5
+-0x1.903494p+3
+0x1.5d8044p+6
+0x1.0330e2p+4
+0x1.956188p+3
+0x1.9716c8p+5
+0x1.9b053ep+2
+0x1.26b98ap+5
+0x1.0b77p+3
+-0x1.ad2e28p+3
+0x1.30a1fap+4
+0x1.f41f1ep+2
+0x1.58c6eep+6
+0x1.4cd264p+3
+0x1.2f67c2p+6
+0x1.17e59ap+5
+0x1.59172cp+6
+0x1.3bb328p+4
+0x1.2a1c4ap+4
+0x1.11986p+6
+0x1.694528p+5
+0x1.d5535ap+4
+0x1.c2a2a4p+5
+0x1.4d88eap+4
+-0x1.e7e718p-1
+0x1.69dd4ap+5
+-0x1.4eca08p+1
+-0x1.c3eb44p+3
+0x1.2a4a8p+3
+0x1.d38d02p+5
+0x1.521b76p+6
+0x1.307698p+4
+0x1.8609c2p+4
+-0x1.facdd8p-3
+-0x1.2292p+3
+0x1.35cbf8p+1
+0x1.4390ecp+4
+0x1.948c06p+4
+-0x1.58cfb4p+3
+0x1.4b4b1cp+3
+0x1.ec863ap+5
+0x1.7868acp+4
+0x1.0c6a56p+6
+0x1.e8f6a6p+1
+0x1.f904cep+5
+0x1.d293c8p+4
+-0x1.35c3e8p+3
+0x1.323624p+4
+0x1.1985dep+4
+0x1.300366p+2
+0x1.cf14fap+5
+0x1.a32ab2p+5
+0x1.fb2286p+5
+0x1.071ed4p+6
+-0x1.25c488p+3
+0x1.5bd4b6p+5
+0x1.bfa83ap+4
+0x1.08f0dep+3
+0x1.f997b4p+4
+0x1.7368ccp+5
+0x1.590e04p+5
+0x1.57d704p+6
+0x1.c5aacep+5
+-0x1.54ee06p+2
+0x1.6191aap+3
+0x1.da9cap+5
+0x1.2fde0ap+5
+0x1.065a4ap+6
+0x1.1d3006p+6
+0x1.81e26ep+2
+0x1.ebf4dap+5
+0x1.cef564p+4
+0x1.922a5ep+3
+0x1.05e368p+3
+-0x1.245f16p+1
+0x1.479e9ap+3
+0x1.2b5394p+5
+0x1.ad8dacp+3
+0x1.ae750ep+3
+0x1.9a4daap+4
+-0x1.825edep+2
+0x1.312b9ap+6
+0x1.18e142p+4
+0x1.63bd86p+5
+0x1.252456p+4
+0x1.ba9c2ep+5
+-0x1.e576a4p+0
+0x1.14a2c4p+6
+0x1.0a073cp+5
+0x1.dcec16p+4
+-0x1.9ff9fap+2
+-0x1.5eb4f8p-2
+-0x1.d4075p+2
+0x1.cb0356p+2
+0x1.b902d6p+5
+0x1.3fdc32p+2
+0x1.5d971p+6
+0x1.84e158p+4
+0x1.95b4c4p+5
+-0x1.3e79ep+3
+0x1.fd2dc8p+5
+0x1.0d6f1ep+6
+0x1.4d02bp+5
+0x1.f11f1p+4
+0x1.576072p+4
+0x1.6dd086p+4
+0x1.0e00d2p+5
+0x1.995574p+5
+0x1.483b64p+5
+0x1.32e292p+3
+0x1.564096p+5
+0x1.64c174p+5
+0x1.54eccap+2
+0x1.10debap+5
+0x1.622066p+5
+0x1.207182p+2
+0x1.e8fb92p+5
+0x1.fc096ap+5
+0x1.3a7646p+1
+0x1.2b9d32p-1
+0x1.1b13f8p+6
+0x1.90947ap+2
+-0x1.b8d3acp+3
+0x1.b6a486p+3
+0x1.49a914p+6
+0x1.2e0d82p+6
+0x1.a6b1aep+5
+0x1.2511e4p+5
+0x1.da5904p+5
+0x1.d5b054p+4
+0x1.2a5f2cp+6
+0x1.08678ap+6
+0x1.f9e99ap+5
+0x1.916dfp+4
+0x1.bca612p+5
+0x1.1d10fcp+5
+0x1.5f1accp+6
+-0x1.cdae76p+2
+0x1.4cc6d2p+6
+0x1.496142p+6
+-0x1.a2389ap+3
+0x1.de417ap+5
+0x1.5db35ap+2
+0x1.c3bfp+4
+0x1.494e5cp+1
+0x1.653f3ep+3
+0x1.184762p+0
+0x1.11cd68p+6
+0x1.278d82p+5
+0x1.ee46e8p+3
+0x1.3eedbap+6
+0x1.2f0584p+5
+0x1.1c418ap+5
+0x1.4c0c6ap+5
+0x1.20bc1ap+5
+0x1.4a866cp+4
+0x1.f57228p+4
+0x1.0d82a8p+6
+0x1.4b7808p+6
+0x1.32497p+6
+0x1.53a728p+6
+0x1.a90c84p+5
+0x1.e1b57cp+5
+-0x1.2e0af6p+2
+0x1.c3ee6cp+2
+0x1.271e9ap+4
+0x1.62dcfap+6
+0x1.d0991p+1
+0x1.3b6862p+6
+0x1.dad92p+4
+0x1.28e45ap+3
+0x1.a299a8p+3