diff --git a/benchtests/Makefile b/benchtests/Makefile
index 22698a9853..36b8296958 100644
--- a/benchtests/Makefile
+++ b/benchtests/Makefile
@@ -40,6 +40,7 @@ bench-math := \
   cosh \
   erf \
   erfc \
+  erff \
   exp \
   exp10 \
   exp10f \
diff --git a/benchtests/erff-inputs b/benchtests/erff-inputs
new file mode 100644
index 0000000000..499cc83819
--- /dev/null
+++ b/benchtests/erff-inputs
@@ -0,0 +1,795 @@
+## args: float
+## ret: float
+## includes: math.h
+# Random inputs in [0,b=0x1.f5a888p+1]
+# where b in the smallest number such that erff(b) rounds to 1 (to nearest)
+## name: workload-random
+0x1.18bdeap+0
+0x1.a0baaep+1
+0x1.3bea6cp+1
+0x1.5d7642p-2
+0x1.f384dap+0
+0x1.4c5fb8p+1
+0x1.e58292p+0
+0x1.f235b4p+1
+0x1.d0864ap+0
+0x1.c9eaa6p+0
+0x1.7ebbb8p+1
+0x1.4f1886p+1
+0x1.527632p+1
+0x1.bc8684p+0
+0x1.bb42acp+0
+0x1.f83f2ap-1
+0x1.af5eeep+0
+0x1.4ca57p-2
+0x1.30fb92p-2
+0x1.c333eep-1
+0x1.2b19b2p-1
+0x1.6b8d48p-1
+0x1.1abb34p-5
+0x1.399a96p-6
+0x1.4d6a38p-2
+0x1.281754p+0
+0x1.de3624p+1
+0x1.d0e6e4p+0
+0x1.860874p+1
+0x1.ceb926p-1
+0x1.41535ap+1
+0x1.4e977cp+0
+0x1.c0699cp+1
+0x1.c5953p-2
+0x1.0f851cp+1
+0x1.5fe912p+1
+0x1.d1c0ep-5
+0x1.983f12p+1
+0x1.afb2d6p+0
+0x1.1f8d36p+1
+0x1.950f7ap+1
+0x1.5b604p+1
+0x1.82afcap-2
+0x1.870554p+0
+0x1.45e22ap-1
+0x1.fe83e2p+0
+0x1.b1e67ep+1
+0x1.ca2412p+1
+0x1.4252dcp-3
+0x1.cf28a4p+1
+0x1.347f42p-1
+0x1.bc27dap+1
+0x1.f048b4p+0
+0x1.d9f5fp+0
+0x1.075d56p+1
+0x1.dac2dep+0
+0x1.d4b8c8p+1
+0x1.0abfa4p+1
+0x1.a8c8b2p+1
+0x1.e8c7fep+0
+0x1.8c19d6p+1
+0x1.06465ep+1
+0x1.e41f0cp+1
+0x1.cc2bfp+0
+0x1.0dc5a2p+1
+0x1.1910aep-1
+0x1.ee987ep-2
+0x1.2aa2d6p+0
+0x1.255dep+1
+0x1.3c5f6cp+1
+0x1.8f4982p+0
+0x1.3e9b28p+1
+0x1.bd9e1cp-1
+0x1.71dcc4p+0
+0x1.6d19b6p+1
+0x1.cc31aep+1
+0x1.9ee44p+1
+0x1.03ad5ep-2
+0x1.ed9204p+0
+0x1.f3c032p-5
+0x1.3268cep+1
+0x1.2c198cp+1
+0x1.a1b458p-1
+0x1.20d8ccp+1
+0x1.95c75p-1
+0x1.5919b6p+1
+0x1.aef4c4p+1
+0x1.114e5ap+0
+0x1.0f5f62p+0
+0x1.ba566cp+1
+0x1.24edccp+1
+0x1.e2d818p+1
+0x1.5021eap+1
+0x1.9869f4p+0
+0x1.053fdep+1
+0x1.324de8p+1
+0x1.379fcep-2
+0x1.3730c8p-3
+0x1.32a75p+1
+0x1.86adcep+1
+0x1.b4aa84p+1
+0x1.1f2b62p+1
+0x1.21bfe4p-6
+0x1.a51b1ep+1
+0x1.073298p+0
+0x1.d77154p+1
+0x1.59a0b2p+1
+0x1.07bc9cp+1
+0x1.d8577ep+1
+0x1.96587ap+1
+0x1.77f71cp+1
+0x1.cdf78ep+1
+0x1.c6f86ep-1
+0x1.61dc9p+1
+0x1.80340cp+0
+0x1.e1471p+1
+0x1.76733p-1
+0x1.212d24p+0
+0x1.e2a7b4p-2
+0x1.25208ep+0
+0x1.2fbf6p+0
+0x1.a3daf8p-1
+0x1.2882b6p+1
+0x1.e1209ep+1
+0x1.37a90ap-1
+0x1.7cd7acp+0
+0x1.4b4dc8p+1
+0x1.3decf8p+1
+0x1.aad7bep+0
+0x1.cf4796p-1
+0x1.2de694p+0
+0x1.10a15cp+0
+0x1.dce9c6p+1
+0x1.e47718p+1
+0x1.ec1044p+1
+0x1.1279b8p+1
+0x1.68c6e2p+1
+0x1.07517cp-2
+0x1.73674ap+1
+0x1.5bb68p-2
+0x1.5b3414p-1
+0x1.3cd5d6p-2
+0x1.b069b4p+1
+0x1.3cdf3ap-2
+0x1.f7932ap-5
+0x1.3357bp+1
+0x1.af55b6p+1
+0x1.e189f6p+1
+0x1.d81feap+1
+0x1.0d8702p+1
+0x1.d9c8ap+1
+0x1.de49d8p-2
+0x1.4a2eacp-6
+0x1.a7bf2ep+0
+0x1.72abdcp+0
+0x1.183c76p+0
+0x1.69009cp+0
+0x1.37294ap+0
+0x1.911bdep+0
+0x1.304408p-1
+0x1.be4f9ap+0
+0x1.60df3p+0
+0x1.c0025ep-2
+0x1.91831cp-1
+0x1.de68ep+1
+0x1.9d1bf8p-2
+0x1.605accp-3
+0x1.9466b8p+1
+0x1.30e7d2p+1
+0x1.adeb88p-1
+0x1.be9564p+1
+0x1.a3ae6ap+1
+0x1.0bad16p+1
+0x1.ce0ddap+1
+0x1.22fd8p-1
+0x1.fb2daap-1
+0x1.edc37ap+1
+0x1.f8ef0ap+0
+0x1.71c7bcp+0
+0x1.60ddd4p+0
+0x1.6beb28p-4
+0x1.42d09cp-5
+0x1.ef9e2cp+1
+0x1.3a7b96p+1
+0x1.3be378p-2
+0x1.c2043ep+1
+0x1.ab3bd2p+1
+0x1.186ef4p+1
+0x1.490ea4p+0
+0x1.6e16fap-1
+0x1.0a592p+0
+0x1.66c314p+1
+0x1.19e4fp+1
+0x1.1078a4p+0
+0x1.1ece24p+0
+0x1.927f5cp+0
+0x1.9ee168p+0
+0x1.a89ccp+1
+0x1.71b4b6p+1
+0x1.ae1a7p-1
+0x1.aa4beap+0
+0x1.46f0c6p-2
+0x1.6ba02p-1
+0x1.39bf9p+1
+0x1.da2a6ep+0
+0x1.e163eap+1
+0x1.e3200ap+1
+0x1.578452p-2
+0x1.2d62aep+1
+0x1.1a996ap+0
+0x1.da16ecp+1
+0x1.6fab36p+0
+0x1.ecf7fcp+1
+0x1.b5774ap+1
+0x1.73f4dep+0
+0x1.95530ap+1
+0x1.0c11c2p+1
+0x1.82aa7cp-2
+0x1.2fee4p+0
+0x1.15b67cp+0
+0x1.69fe3ap-2
+0x1.e9c74cp+1
+0x1.f18e5cp+1
+0x1.1ad88ap+1
+0x1.2fd69ep-1
+0x1.b20444p+1
+0x1.95cf7p+1
+0x1.993854p+1
+0x1.982b56p-3
+0x1.542086p+1
+0x1.daa528p-1
+0x1.f0b574p+0
+0x1.275892p+1
+0x1.d88506p+1
+0x1.81f2fcp+1
+0x1.9a5b38p+0
+0x1.e040f4p-3
+0x1.35ead2p+1
+0x1.e8720cp-2
+0x1.0fb3b6p+1
+0x1.91634ep+1
+0x1.471eb4p+1
+0x1.ce31b2p+0
+0x1.a31b6ap+0
+0x1.45199p+1
+0x1.88ad2p+1
+0x1.8a6c5ep+1
+0x1.3e3dc4p+0
+0x1.3d37e6p-10
+0x1.7be9eap-1
+0x1.9ae6acp-3
+0x1.8f7068p+0
+0x1.6a3e36p-1
+0x1.72518ep-3
+0x1.a69b2ep+0
+0x1.06f66ep+0
+0x1.4a611ep-7
+0x1.db806p-1
+0x1.4edbdep+1
+0x1.71b822p+1
+0x1.4bcdd2p+1
+0x1.86c9fep+0
+0x1.18d17cp+0
+0x1.bede3ap-2
+0x1.a67d26p+0
+0x1.2a24c8p+0
+0x1.515eaep+0
+0x1.b09292p+0
+0x1.ac617cp-1
+0x1.f489a4p+1
+0x1.c7d8b4p+0
+0x1.58ab96p-2
+0x1.b05058p+0
+0x1.b96b4ep+1
+0x1.989734p+1
+0x1.e3e296p+1
+0x1.1198dp+1
+0x1.1e80acp+0
+0x1.4d14eap+0
+0x1.2c71b4p+1
+0x1.76094cp+1
+0x1.2798dep+0
+0x1.54283ep+1
+0x1.eded84p-1
+0x1.478342p-8
+0x1.b05644p+0
+0x1.0c7892p+0
+0x1.14a794p+0
+0x1.6c3302p+0
+0x1.b09d68p+1
+0x1.a7f6f2p+1
+0x1.2bd8fap-3
+0x1.af5d4ap+1
+0x1.dd6366p+1
+0x1.bb35d2p+1
+0x1.9c0084p+1
+0x1.fecaccp-1
+0x1.fa8a3cp-1
+0x1.3fc164p+1
+0x1.6d2c9ep+1
+0x1.88348ap+0
+0x1.571fa4p-7
+0x1.c5e7eep+1
+0x1.3fd334p-1
+0x1.7fa944p+1
+0x1.7b77e8p+1
+0x1.1d562p+0
+0x1.8f723ep+1
+0x1.2da99cp+1
+0x1.1ba908p+1
+0x1.b67844p+0
+0x1.13d734p-9
+0x1.8f35bep-4
+0x1.e10636p+1
+0x1.5e90f2p+1
+0x1.eae2b4p+1
+0x1.4565d2p-2
+0x1.695658p+1
+0x1.a5acecp+1
+0x1.594ac6p+0
+0x1.19697p-1
+0x1.b58114p-4
+0x1.9e658ap-3
+0x1.680022p+1
+0x1.bc4e46p-3
+0x1.5a63e6p+0
+0x1.0ce218p+1
+0x1.6b57c4p+0
+0x1.02ef42p+1
+0x1.beb706p-3
+0x1.872452p+0
+0x1.7e11c6p-1
+0x1.abfbfcp-2
+0x1.539022p+0
+0x1.5533ep-1
+0x1.9a3f96p+1
+0x1.f91f8ep+0
+0x1.1055e6p+1
+0x1.a5b114p-4
+0x1.f227fep+0
+0x1.a29084p+1
+0x1.d6d17ap-2
+0x1.69ca2cp+1
+0x1.f50064p+1
+0x1.f34d2ep+1
+0x1.3ce0bap-3
+0x1.04e4ep+1
+0x1.6074dcp+1
+0x1.34a3ccp+0
+0x1.4554e4p-1
+0x1.bcc5dcp+1
+0x1.5bf646p-1
+0x1.b1d1dep+0
+0x1.accaeep-2
+0x1.6b27a4p+1
+0x1.70484ep+1
+0x1.0679e6p+1
+0x1.6355a6p+1
+0x1.6f5c52p+1
+0x1.40c4d2p+1
+0x1.553edp+1
+0x1.607faap+1
+0x1.6a49c2p+1
+0x1.5d70bcp+1
+0x1.043702p+0
+0x1.e8b732p+1
+0x1.7e7108p+0
+0x1.c08a82p+0
+0x1.63aa1p+1
+0x1.871e4ep+1
+0x1.29bb98p+1
+0x1.c6b566p+1
+0x1.838e08p-3
+0x1.013a24p+1
+0x1.aa4d8p+1
+0x1.72ddacp+0
+0x1.0e228ap+1
+0x1.2b9ad4p+0
+0x1.97967ep+1
+0x1.70b072p+0
+0x1.3193b2p-2
+0x1.65fafep+1
+0x1.79b50ap+0
+0x1.18ee5p-1
+0x1.f515bep+1
+0x1.8c32cep+1
+0x1.8c9946p+1
+0x1.92ef08p-1
+0x1.af71dep+1
+0x1.4363fp+1
+0x1.ffee74p+0
+0x1.281784p+1
+0x1.d2b744p+1
+0x1.48d82ap+0
+0x1.35cfd8p+1
+0x1.291464p+1
+0x1.89b068p-4
+0x1.66a79ap-1
+0x1.f1691ep+1
+0x1.5a43bap+1
+0x1.afcd4ap+1
+0x1.311728p+1
+0x1.9ab1e4p+0
+0x1.6eb968p+1
+0x1.401d62p+0
+0x1.812e92p+0
+0x1.61454ap+0
+0x1.8d76a6p+1
+0x1.57feeep-1
+0x1.aae1b8p-1
+0x1.bb8362p+0
+0x1.e7093ep+0
+0x1.178258p+1
+0x1.6bd848p+0
+0x1.d0245cp+1
+0x1.7e10ecp-2
+0x1.3cfbdap-3
+0x1.743466p+1
+0x1.d2c008p+1
+0x1.dbae7cp+0
+0x1.612f8ep+0
+0x1.73c834p+0
+0x1.bc1deap+1
+0x1.85e39p-1
+0x1.2d362ap+1
+0x1.c9d2f4p+0
+0x1.aa4136p-1
+0x1.7e7f0ap-1
+0x1.5612bp+1
+0x1.b03fbep+0
+0x1.8dfa12p+1
+0x1.7447c6p+0
+0x1.d33da4p-1
+0x1.dff4ap+0
+0x1.db7ee6p+1
+0x1.de0caep+0
+0x1.2898acp-4
+0x1.07e456p+1
+0x1.19621p-1
+0x1.8a3146p+1
+0x1.25537ep+1
+0x1.0fe8a6p+0
+0x1.b18676p+1
+0x1.5a0bc6p+0
+0x1.81e70cp+1
+0x1.a92e9cp+1
+0x1.9d7552p+1
+0x1.63f83p-3
+0x1.787b68p+0
+0x1.35ad04p+1
+0x1.101692p-3
+0x1.700adcp+1
+0x1.e3bcfcp+0
+0x1.398884p+0
+0x1.0c4372p-1
+0x1.c36118p+1
+0x1.fc1c62p+0
+0x1.27fd2ep+1
+0x1.e5920ap+0
+0x1.44e2a8p-6
+0x1.2050dep-3
+0x1.65dbe6p+1
+0x1.34b6dp+0
+0x1.97961ep+0
+0x1.4adfa2p+1
+0x1.b521bp-1
+0x1.24ecd6p+0
+0x1.cc8218p+1
+0x1.612bf2p+0
+0x1.0de564p-1
+0x1.1ffc94p+1
+0x1.7f71e2p+0
+0x1.fd4a06p-1
+0x1.4cee9ep+1
+0x1.7207fep-1
+0x1.16de3ep+0
+0x1.bca0f4p+0
+0x1.58fcdcp-1
+0x1.054ecep+1
+0x1.1b61cep+1
+0x1.d0228ep-2
+0x1.6f7f4ep+1
+0x1.b64b04p-1
+0x1.4294b6p-4
+0x1.6eaf3ep+1
+0x1.f05fb6p+1
+0x1.df333ep+1
+0x1.2623fcp+1
+0x1.16ea64p+1
+0x1.de1d66p+0
+0x1.c31e48p-2
+0x1.ba373p-1
+0x1.b6848ap+1
+0x1.30fe1p+1
+0x1.f6f3ap-2
+0x1.243ebap+0
+0x1.079442p+1
+0x1.4b7264p+1
+0x1.a9c97ep+0
+0x1.1272e8p+1
+0x1.9ee754p+1
+0x1.d54e68p+0
+0x1.172b06p+1
+0x1.d4935cp+1
+0x1.3e050ep+1
+0x1.220bdap+1
+0x1.849544p+0
+0x1.478ea8p+0
+0x1.c3ac82p-3
+0x1.840b62p+1
+0x1.3143cp+1
+0x1.ed69dep-1
+0x1.5c42f4p+1
+0x1.805356p+1
+0x1.a2b3bcp-5
+0x1.6fb19cp-1
+0x1.5f4f98p+1
+0x1.d2235ap+1
+0x1.e67092p+1
+0x1.0b3f3ap-1
+0x1.8351ap+0
+0x1.2aed02p-1
+0x1.68ca1ap+1
+0x1.e88534p+0
+0x1.a4e0e4p+0
+0x1.42332p+0
+0x1.36a7fep+0
+0x1.d739e6p+1
+0x1.b468dep+0
+0x1.ec4636p+0
+0x1.306664p+0
+0x1.15466ap-1
+0x1.7ba956p+0
+0x1.b7d10ep+1
+0x1.f36572p-2
+0x1.932fd8p+0
+0x1.e22a8ep+1
+0x1.e11602p+1
+0x1.808bbcp+1
+0x1.8aff22p+0
+0x1.7eab7cp+1
+0x1.10cbf8p+1
+0x1.df09c6p+0
+0x1.2307eap+1
+0x1.7821f6p+0
+0x1.7f6ccap+1
+0x1.a61192p+1
+0x1.0290cp+1
+0x1.590158p+1
+0x1.50313ap+1
+0x1.9cc2ecp+0
+0x1.5d787p+0
+0x1.0c14e2p-1
+0x1.79aecp+0
+0x1.6d57ecp+1
+0x1.d8bffp-3
+0x1.c5fe96p+1
+0x1.f3643ap-2
+0x1.7f3df2p+0
+0x1.acffe2p+1
+0x1.69eed2p+1
+0x1.8eed02p+1
+0x1.4ae8dcp-1
+0x1.303e76p+1
+0x1.950e96p-3
+0x1.43374ep-1
+0x1.4fa4b2p-1
+0x1.ff8ee8p-1
+0x1.4fa0e8p+1
+0x1.06bfdcp+1
+0x1.b1272cp+1
+0x1.b6bc16p+1
+0x1.b84282p+1
+0x1.e810fcp+1
+0x1.3b7b94p+1
+0x1.231086p+1
+0x1.f6578p+0
+0x1.dc115ep+1
+0x1.43549ap+1
+0x1.f7f6c8p+0
+0x1.f0b0fp-2
+0x1.261606p-2
+0x1.289c68p+1
+0x1.437272p+0
+0x1.9a239ep-1
+0x1.a6e29ap-1
+0x1.e5a916p+1
+0x1.a7138ap-4
+0x1.daa6b8p+1
+0x1.71b6e2p-1
+0x1.39334p+1
+0x1.b6243ep-2
+0x1.b756fap+1
+0x1.2a003ep-1
+0x1.e7ea84p+1
+0x1.2a7954p+1
+0x1.723274p+1
+0x1.4f6fd6p+1
+0x1.97163cp-2
+0x1.9cd784p+1
+0x1.88de72p+0
+0x1.e4693p-2
+0x1.43a1p+1
+0x1.f74888p+0
+0x1.69be38p+1
+0x1.b498fcp+0
+0x1.409746p+1
+0x1.68e758p+1
+0x1.3b0c9ep+0
+0x1.09976ap+1
+0x1.3e39a8p-2
+0x1.5686fcp+1
+0x1.46ade2p+1
+0x1.5d2cb2p+1
+0x1.6432acp+0
+0x1.9fc728p+1
+0x1.7d399ep+1
+0x1.175a2ap-1
+0x1.8558dcp+1
+0x1.f53ebp-1
+0x1.20053cp+0
+0x1.7c2396p+1
+0x1.793deep+1
+0x1.5a8a6ep+1
+0x1.c81fbep-2
+0x1.70591ap-1
+0x1.6a0bdap-1
+0x1.8fc3d4p+0
+0x1.40a06ep+1
+0x1.cc8688p+1
+0x1.d35e88p+1
+0x1.b4dacp-1
+0x1.e7224p+1
+0x1.842e6p+0
+0x1.29d694p+1
+0x1.b75514p+0
+0x1.c34e7ap+0
+0x1.1cb6fcp-3
+0x1.5ae01ep-1
+0x1.4cf9f8p+0
+0x1.a302fep+1
+0x1.8ff134p-2
+0x1.c4891cp+1
+0x1.ef35f8p-1
+0x1.76fd22p+1
+0x1.9c63f8p-1
+0x1.100294p-2
+0x1.196498p-1
+0x1.b3ba34p+1
+0x1.ed86c2p-2
+0x1.9b3752p+1
+0x1.cf7f42p+1
+0x1.eb2154p+0
+0x1.15e3f4p-1
+0x1.0b283ap+1
+0x1.0be5ap+1
+0x1.421758p+0
+0x1.ed0372p+0
+0x1.58073ep+1
+0x1.d7685ep+1
+0x1.02e13ep+1
+0x1.ba7496p-1
+0x1.bb081p+1
+0x1.a16588p+1
+0x1.f031cap+1
+0x1.da56fp+1
+0x1.75544ep+1
+0x1.31019cp+1
+0x1.279198p+1
+0x1.95c92cp+0
+0x1.f2e7f2p+0
+0x1.8caecp+0
+0x1.72be8cp-6
+0x1.39d196p-3
+0x1.cb355ap-2
+0x1.93f8a4p-2
+0x1.84de94p+1
+0x1.f03fp-1
+0x1.a3f4b8p+0
+0x1.b300e8p+1
+0x1.b5a536p+1
+0x1.7e2818p+0
+0x1.5213dep+1
+0x1.2017eep+1
+0x1.e245b2p+1
+0x1.ff615ap+0
+0x1.659b7cp+0
+0x1.b823fep+0
+0x1.f0456cp+1
+0x1.026b12p+1
+0x1.7bba46p+1
+0x1.e6822ap+1
+0x1.b48a4p+0
+0x1.5291c8p+1
+0x1.aa99c2p-3
+0x1.10d8e8p+0
+0x1.2581f4p+1
+0x1.616a76p+0
+0x1.c311eep-1
+0x1.26f70ap-3
+0x1.3f1c3ap+1
+0x1.c7e808p-2
+0x1.111654p+0
+0x1.2f8042p+1
+0x1.3e6674p-1
+0x1.a1039ap+1
+0x1.5b9178p-1
+0x1.0db16p-1
+0x1.b58512p+1
+0x1.5eb1d6p-1
+0x1.418044p+0
+0x1.2ffe0ep+1
+0x1.378208p+1
+0x1.9ea87ap+0
+0x1.e54596p-2
+0x1.f6d968p-1
+0x1.6b7056p+1
+0x1.f11f32p-1
+0x1.7a3096p+1
+0x1.c1c826p+0
+0x1.efe552p+0
+0x1.e61396p+1
+0x1.e37e06p+1
+0x1.82b3ap+0
+0x1.966dccp+1
+0x1.0e466p+1
+0x1.efed28p+1
+0x1.e36132p+1
+0x1.333756p+1
+0x1.3a365p+1
+0x1.ad9976p-5
+0x1.bd627ep+1
+0x1.51c5dp+1
+0x1.687f2ap+0
+0x1.a58778p+1
+0x1.bca172p+0
+0x1.99d50ep-1
+0x1.414508p+1
+0x1.ccca06p+0
+0x1.ba7c34p+1
+0x1.091ed8p+1
+0x1.2de682p+0
+0x1.0c339cp+0
+0x1.7ef23ep+1
+0x1.937f26p+1
+0x1.2f33a6p+0
+0x1.0a89dep-2
+0x1.c5e012p-1
+0x1.0b1b7p+1
+0x1.afc0b8p+1
+0x1.e354ecp+1
+0x1.905558p-6
+0x1.892ff8p+1
+0x1.c913d8p+1
+0x1.9fe02cp+0
+0x1.035d54p+1
+0x1.cdd148p+0
+0x1.b51494p-2
+0x1.b112bap+0
+0x1.2cab5cp+1
+0x1.23cf7ap+0
+0x1.ec743ap-1
+0x1.49a22p+1
+0x1.4dc4fcp+1
+0x1.e0a0bp-1
+0x1.2ea1c6p+1
+0x1.4a8fa8p-3
+0x1.591904p-1
+0x1.bb6668p+0
+0x1.27b8cp+1
+0x1.08df38p+1
+0x1.e848c6p+1
+0x1.d2ec06p+1
+0x1.d169f4p-1
+0x1.626128p-1
+0x1.708f46p-1
+0x1.ddf4dcp+1
+0x1.cd6c44p+1
+0x1.f4a4aep+1
+0x1.f1c93ep+1
+0x1.0e0e86p+0
+0x1.a4fe6cp+1
+0x1.fc563ep+0
+0x1.78772ep+0
+0x1.55b78ep+0
+0x1.fa51f6p-1
+0x1.8f7536p+1
+0x1.f05a68p+1
+0x1.062674p+0