diff --git a/benchtests/Makefile b/benchtests/Makefile
index 36b8296958..7eaea139a9 100644
--- a/benchtests/Makefile
+++ b/benchtests/Makefile
@@ -40,6 +40,7 @@ bench-math := \
   cosh \
   erf \
   erfc \
+  erfcf \
   erff \
   exp \
   exp10 \
diff --git a/benchtests/erfcf-inputs b/benchtests/erfcf-inputs
new file mode 100644
index 0000000000..2c46593140
--- /dev/null
+++ b/benchtests/erfcf-inputs
@@ -0,0 +1,795 @@
+## args: float
+## ret: float
+## includes: math.h
+# Random inputs in [0,b=0x1.41bbf6p+3]
+# where b in the smallest number such that erfcf(b) rounds to 0 (to nearest)
+## name: workload-random
+0x1.599288p+1
+0x1.6309e8p-1
+0x1.c02778p+0
+0x1.e654dp+1
+0x1.b2547ep+1
+0x1.1715dap+1
+0x1.eec122p+2
+0x1.b6d106p+2
+0x1.8d823ap+2
+0x1.b7517p+2
+0x1.ce66e2p+2
+0x1.a4513p+2
+0x1.115cfcp+2
+0x1.971ecp-1
+0x1.15e002p+1
+0x1.35b134p+3
+0x1.2e5176p+3
+0x1.d5d11ep+2
+0x1.a546fep+1
+0x1.e4124p+2
+0x1.9eac9ap+2
+0x1.718dep-2
+0x1.6c37b8p+1
+0x1.6f5702p+2
+0x1.bd468ap+2
+0x1.a033ep+1
+0x1.33eabep+2
+0x1.8374d8p+2
+0x1.3bd382p+0
+0x1.7dcfc6p+1
+0x1.b88ed2p+1
+0x1.623994p+2
+0x1.607a4cp+0
+0x1.9246acp+2
+0x1.056e38p+1
+0x1.04644cp+1
+0x1.998e4ep+2
+0x1.c046c4p+1
+0x1.c4dc78p+1
+0x1.25f6a2p+1
+0x1.72376cp-1
+0x1.d4b032p+2
+0x1.111456p+3
+0x1.adea1ap+1
+0x1.622bfap+2
+0x1.e28086p+2
+0x1.a6a556p+2
+0x1.410c9ep+1
+0x1.02f2e6p+3
+0x1.b0388cp+0
+0x1.b047bap+1
+0x1.1f3b5ap+2
+0x1.9ac788p+1
+0x1.a40238p+2
+0x1.d92756p+1
+0x1.36e328p+1
+0x1.dd92ap-1
+0x1.329f6p+1
+0x1.fe2718p+1
+0x1.1973d6p+2
+0x1.d63fe6p+1
+0x1.9546cep+1
+0x1.faca46p+2
+0x1.de40b4p-2
+0x1.d540dep+2
+0x1.888322p+2
+0x1.c9b20cp+0
+0x1.b66b84p+2
+0x1.4e6e08p+1
+0x1.61f8f4p+2
+0x1.5d9732p+2
+0x1.d43d28p-1
+0x1.eba1e2p+2
+0x1.5c7a1cp+0
+0x1.427124p+2
+0x1.3d135ap+3
+0x1.9b3b7ap+2
+0x1.5c719cp+0
+0x1.6df80ap+1
+0x1.1bd402p+2
+0x1.0c01f8p+2
+0x1.f84896p+0
+0x1.1fa426p+3
+0x1.dfd60cp-3
+0x1.a6c104p+2
+0x1.7de2p-1
+0x1.072abp+3
+0x1.46a4a4p+2
+0x1.cdaa24p+2
+0x1.fda388p+1
+0x1.d2e65ep+2
+0x1.5ff646p+0
+0x1.4bdb28p+1
+0x1.2dde6cp+3
+0x1.4a8e5p+1
+0x1.3467cp+3
+0x1.c9eefep+2
+0x1.2f665ep+3
+0x1.2ec086p+1
+0x1.1107c6p+3
+0x1.efc5fcp+2
+0x1.7c6bc8p+1
+0x1.d3b834p+0
+0x1.6064dep+0
+0x1.953526p-1
+0x1.38a0e4p+3
+0x1.a58218p+1
+0x1.ed8578p+2
+0x1.312ec2p+2
+0x1.d884fap+0
+0x1.345e2ep+2
+0x1.e89836p+1
+0x1.1fdd7ap+3
+0x1.d03192p+2
+0x1.22d9f8p+2
+0x1.14d88ap+3
+0x1.c22afp-1
+0x1.eaeac2p+2
+0x1.2252e2p+2
+0x1.9149d2p-1
+0x1.c40d7p+0
+0x1.0c0ccap+3
+0x1.815152p+2
+0x1.4f39d4p+1
+0x1.30b01cp+3
+0x1.50c01cp+2
+0x1.cbb3fp+2
+0x1.911ba8p+0
+0x1.bee5e4p+0
+0x1.c33322p+0
+0x1.54c6c6p+1
+0x1.184e36p+2
+0x1.066b9cp+2
+0x1.4be8ap+1
+0x1.927128p+2
+0x1.5a0308p+2
+0x1.8d10dp+2
+0x1.1c890cp+0
+0x1.38b936p+3
+0x1.74dc9cp+1
+0x1.28011ap+2
+0x1.21c7b6p+2
+0x1.1aaf36p+3
+0x1.c1befep-1
+0x1.f12b48p+1
+0x1.1985c6p+3
+0x1.f736fp+1
+0x1.0a6372p+3
+0x1.03241cp+3
+0x1.0f18ccp+1
+0x1.1c4968p+2
+0x1.fcd214p+1
+0x1.a23ff8p-2
+0x1.f3e3e6p+2
+0x1.0967dep+3
+0x1.2e3c1cp+2
+0x1.e30dfcp+0
+0x1.5ec456p+1
+0x1.24368cp+3
+0x1.1206a6p+3
+0x1.f5733ap+2
+0x1.6db898p+2
+0x1.06f78ap+2
+0x1.588132p+2
+0x1.41c9dep+1
+0x1.278b34p+2
+0x1.0ef4a2p+2
+0x1.f26bfap+0
+0x1.8d5252p+2
+0x1.ffa79cp+2
+0x1.12fc7ep+0
+0x1.8dd8a6p+2
+0x1.41d33cp+2
+0x1.1920b2p+3
+0x1.ecfc9p+2
+0x1.455fb8p+2
+0x1.6c5b3ep+2
+0x1.ecf518p+2
+0x1.df076p+2
+0x1.2dc028p+3
+0x1.a23cf6p-1
+0x1.4b9716p+2
+0x1.2b7be4p+3
+0x1.b0f7d8p+2
+0x1.1549c2p+3
+0x1.eaf7d2p+0
+0x1.304f44p+3
+0x1.e9f16ep+2
+0x1.e168dap-4
+0x1.2edb1cp+2
+0x1.07c49ep+2
+0x1.276696p+2
+0x1.b8d964p+2
+0x1.c8ad5ep+2
+0x1.48a2ep+0
+0x1.2fc204p+3
+0x1.2d5d5ap+3
+0x1.275824p+3
+0x1.105ddcp+2
+0x1.f9e7ep-2
+0x1.1877d6p+3
+0x1.8d926p+1
+0x1.a8c6c6p+0
+0x1.d27f48p+2
+0x1.8ec5d2p+2
+0x1.c1bc1ap+2
+0x1.ffe57cp+2
+0x1.0e56a4p+2
+0x1.7e8472p-1
+0x1.1e46b6p+3
+0x1.cd6758p+2
+0x1.75b5fp+2
+0x1.e17b3ep-1
+0x1.41a7dp+3
+0x1.1dd2f4p+3
+0x1.f28c56p-1
+0x1.d04dacp+2
+0x1.9a027ep+1
+0x1.829162p+2
+0x1.269692p+3
+0x1.28dcacp+3
+0x1.c5fd34p+2
+0x1.26b60ep+3
+0x1.c04c98p+1
+0x1.a1fc5cp+2
+0x1.55dac6p+2
+0x1.44e904p-2
+0x1.039adp+2
+0x1.ccd75p+2
+0x1.1c9daep+3
+0x1.3d6232p+3
+0x1.d3da94p+2
+0x1.171392p-1
+0x1.a3ede2p+0
+0x1.79b6e4p-1
+0x1.0c49d8p+1
+0x1.ec1abep+2
+0x1.2bb1d4p+2
+0x1.0e109ep+3
+0x1.145cfep+3
+0x1.1a1726p+3
+0x1.27e514p-1
+0x1.7c51fep-1
+0x1.cd02bp+2
+0x1.8f7d54p+1
+0x1.0f9ea6p+1
+0x1.5b6e0ep+1
+0x1.a5f14p+1
+0x1.1995dap+2
+0x1.0d1664p+3
+0x1.00ae76p+3
+0x1.d2e09p+2
+0x1.5eec0cp+2
+0x1.17423cp+3
+0x1.57152ap+0
+0x1.646646p+1
+0x1.2d0586p+2
+0x1.40e086p+2
+0x1.1cdfa2p+0
+0x1.d0f7fep+0
+0x1.c0a4a8p+0
+0x1.6f885ep+2
+0x1.d485cap+2
+0x1.502522p+2
+0x1.225a7ap+3
+0x1.c67fe6p+2
+0x1.41f3acp+1
+0x1.7cd126p+2
+0x1.c6540cp+2
+0x1.f37b3cp+2
+0x1.79c12cp+0
+0x1.b510d2p+2
+0x1.1d5e48p+3
+0x1.72fac6p+1
+0x1.1ae9p+3
+0x1.1adaa8p+3
+0x1.323476p+3
+0x1.ee54b8p+2
+0x1.8ee008p+2
+0x1.df8f9ap+1
+0x1.27879ep+3
+0x1.1d09f6p+0
+0x1.4ee52ap+1
+0x1.945148p+2
+0x1.51c588p+2
+0x1.f0b77cp+1
+0x1.37676p+3
+0x1.c477b4p+1
+0x1.c3a09p-1
+0x1.53cd4ap+2
+0x1.0c8b04p+2
+0x1.cc42ecp+0
+0x1.18bf72p+2
+0x1.350a3ep+3
+0x1.17ec1ep+3
+0x1.00e4eep+3
+0x1.0e2628p+3
+0x1.467e2cp+1
+0x1.20626ap+3
+0x1.1095c4p+3
+0x1.45ec42p+2
+0x1.2328cap+3
+0x1.03233ep+3
+0x1.56831ap-2
+0x1.62c568p+0
+0x1.828f9ep+2
+0x1.d9325ep+2
+0x1.86dd1p+2
+0x1.27e742p+0
+0x1.05da5ap+1
+0x1.ce91bp+2
+0x1.91f644p-3
+0x1.e2a36ap-1
+0x1.f40ed8p+2
+0x1.0aadbp+1
+0x1.db633ap+2
+0x1.0b9d32p+3
+0x1.0a365p+3
+0x1.7ef782p+2
+0x1.14361cp+3
+0x1.2ef9c6p+3
+0x1.911facp-1
+0x1.9aa1fep+2
+0x1.31febep+2
+0x1.0384bap+2
+0x1.29b746p+2
+0x1.941162p+0
+0x1.428426p+2
+0x1.29bb3cp+3
+0x1.387cb6p+0
+0x1.3d33e8p+2
+0x1.6a11d8p+0
+0x1.4e1ef4p+1
+0x1.4c333ap+2
+0x1.158d86p+3
+0x1.771328p-3
+0x1.7c0164p+0
+0x1.e51d0ep+1
+0x1.16b2dcp+2
+0x1.19968p+2
+0x1.2242ecp+3
+0x1.2142aep+3
+0x1.88fa48p+2
+0x1.ae3f84p+1
+0x1.24080ap+3
+0x1.d0b3e8p+1
+0x1.198ddcp+3
+0x1.a8546ep-2
+0x1.c3cedp+2
+0x1.2f790ep+3
+0x1.feda2ap-2
+0x1.308c06p+3
+0x1.98a752p+0
+0x1.1e5798p+2
+0x1.a26ed4p-1
+0x1.85a83ep+0
+0x1.025ap+2
+0x1.3ca802p+3
+0x1.d852a6p+2
+0x1.f77932p+2
+0x1.0b8c94p+2
+0x1.19332cp+1
+0x1.edf502p+1
+0x1.2a64b8p+3
+0x1.c60fe6p+2
+0x1.08ec18p+3
+0x1.10ba9ep+1
+0x1.e6a58p+2
+0x1.23c154p+3
+0x1.2bb994p+3
+0x1.4f3f9ap+1
+0x1.3744ep+1
+0x1.915a92p-1
+0x1.f50888p+1
+0x1.b6ba4p+1
+0x1.a005aep+2
+0x1.399ba4p+1
+0x1.914f82p+2
+0x1.3ce532p+3
+0x1.1beafp+1
+0x1.1a812p+3
+0x1.b74abp+2
+0x1.3635b2p-2
+0x1.04f086p+2
+0x1.755da8p+2
+0x1.b8cfaep-1
+0x1.1473p+1
+0x1.b8041p+1
+0x1.2f97fap+2
+0x1.b576e4p+2
+0x1.846dap+1
+0x1.e47b2ep+2
+0x1.c2a946p+1
+0x1.3fd7b6p+2
+0x1.dc0f2cp-1
+0x1.7e1218p+1
+0x1.d2c8dcp+2
+0x1.472272p+0
+0x1.641e64p+0
+0x1.01a42ap+2
+0x1.158b02p+2
+0x1.442ab4p+1
+0x1.4dbb1p+2
+0x1.0ed2a4p+3
+0x1.21fa78p+2
+0x1.26437ap-1
+0x1.e14858p+2
+0x1.02e634p+3
+0x1.73491ep+2
+0x1.e354b4p+2
+0x1.87d4bep+1
+0x1.f0ce06p+0
+0x1.2e96bap-1
+0x1.2ae62cp+3
+0x1.386692p+0
+0x1.2aa6aap+3
+0x1.a3d016p+0
+0x1.9313f8p+1
+0x1.80424p-1
+0x1.72453cp+2
+0x1.311d18p+1
+0x1.bc4058p+2
+0x1.702c9p+2
+0x1.350706p+2
+0x1.86324ep+2
+0x1.be1a5p+2
+0x1.2b435cp+3
+0x1.60f778p+0
+0x1.0742d8p+3
+0x1.191bb4p+2
+0x1.e077c6p+1
+0x1.ea9dacp+2
+0x1.7941ep+2
+0x1.d544c8p+2
+0x1.5b5e72p-4
+0x1.ed4b62p+2
+0x1.60cef4p+2
+0x1.63674ap+0
+0x1.d5d54ep+2
+0x1.e61e8p+2
+0x1.54b516p+0
+0x1.ed648cp+2
+0x1.290dcep+0
+0x1.cd0064p+2
+0x1.88b284p-1
+0x1.45d2f6p+0
+0x1.75f344p+2
+0x1.c31888p+1
+0x1.bd1a56p+0
+0x1.23b6fcp+2
+0x1.088244p+2
+0x1.042f36p+3
+0x1.cb7d6ep+2
+0x1.7f0f4ep+2
+0x1.6ef664p+1
+0x1.0c2a46p+2
+0x1.8d0a9ep+1
+0x1.341accp+1
+0x1.e4261ap+2
+0x1.aee89ep+2
+0x1.64e81p-1
+0x1.5e59a4p+1
+0x1.2b8aecp+2
+0x1.17ea2p+3
+0x1.f88bbep+1
+0x1.133afep+1
+0x1.116c6cp+2
+0x1.a4993ep+2
+0x1.f435bcp+2
+0x1.c23a96p+0
+0x1.29a256p+3
+0x1.9744bep-2
+0x1.118a9ep+3
+0x1.2eb6f6p+2
+0x1.d02cc4p+2
+0x1.35b38p+3
+0x1.0684b8p+2
+0x1.07c4fep+3
+0x1.3fe034p+3
+0x1.27334ap+3
+0x1.229376p+3
+0x1.aeaae4p+1
+0x1.f08062p+1
+0x1.933e02p+0
+0x1.1a2702p+0
+0x1.08dafap+2
+0x1.147accp+3
+0x1.345bb8p+3
+0x1.4c184cp+1
+0x1.267932p-1
+0x1.16b15p+2
+0x1.68ceeap+1
+0x1.cea952p-2
+0x1.64652ep+1
+0x1.0947ecp+2
+0x1.39afaap+3
+0x1.7505fcp+2
+0x1.6a0c94p+0
+0x1.424eb2p+0
+0x1.8d8dbp+2
+0x1.124592p+3
+0x1.8ea0f2p+2
+0x1.2d1a14p+3
+0x1.eb3628p+0
+0x1.58d9d6p+2
+0x1.7a22eap+1
+0x1.bbfe54p+1
+0x1.0cf26ep+2
+0x1.d56fc8p+2
+0x1.fedd7p+1
+0x1.dc081ap+2
+0x1.a4fb46p+2
+0x1.f4e956p+2
+0x1.419a3p+2
+0x1.14cdb6p-1
+0x1.dda3bcp+2
+0x1.a3f572p+2
+0x1.4dc052p-1
+0x1.b07ea8p+2
+0x1.3ff024p+2
+0x1.78af36p+2
+0x1.ec8d88p+2
+0x1.c8d4bep+0
+0x1.75ed3ap-2
+0x1.0edf74p+2
+0x1.4a7512p-2
+0x1.273f42p+2
+0x1.b0af26p+2
+0x1.1dd472p+2
+0x1.c2c2d2p+2
+0x1.82549cp+2
+0x1.cc4a1ap+2
+0x1.336554p+2
+0x1.3e7dd4p+3
+0x1.851a02p+2
+0x1.e58456p-1
+0x1.c3a96p+0
+0x1.69782ap+1
+0x1.b508a4p+2
+0x1.122796p-1
+0x1.e31838p-1
+0x1.57532p+1
+0x1.cc35ap+2
+0x1.f49e4ep+1
+0x1.289f1ep+3
+0x1.75758p+0
+0x1.954306p+2
+0x1.e811a8p+0
+0x1.3b405cp-3
+0x1.992492p+1
+0x1.68336p+1
+0x1.1c5196p+0
+0x1.669e84p+2
+0x1.25fc9ep+3
+0x1.4763ep+2
+0x1.25fe76p+1
+0x1.2f2262p+2
+0x1.b6ab0cp+2
+0x1.dddb56p+2
+0x1.a2c142p+1
+0x1.04cb34p+3
+0x1.5e2a7ep+2
+0x1.35f8acp+0
+0x1.511c32p-1
+0x1.9b01bcp+2
+0x1.3a83f8p+1
+0x1.32333cp+2
+0x1.e8680cp+2
+0x1.19be82p+3
+0x1.37a5f8p+3
+0x1.417534p+0
+0x1.6989e6p-1
+0x1.fd92e2p+1
+0x1.1a03e6p+3
+0x1.4a1fbep+0
+0x1.a7f82cp+2
+0x1.07d606p+3
+0x1.2ea5ap+2
+0x1.3261d8p+3
+0x1.2efe5ap-2
+0x1.9262eap+2
+0x1.b771fep-1
+0x1.e5e4p+2
+0x1.a65a04p+0
+0x1.1eaf6p+3
+0x1.8301b2p-1
+0x1.5fee84p+2
+0x1.3493a2p+1
+0x1.26e088p+3
+0x1.3e12dep-3
+0x1.8ff134p+2
+0x1.39ffdep+1
+0x1.d9fb2cp+2
+0x1.ed2af8p-1
+0x1.8f6c72p+0
+0x1.c188b4p+0
+0x1.f31b86p+1
+0x1.eae4fap+0
+0x1.2b4966p+2
+0x1.da647cp+0
+0x1.c91b4ep+2
+0x1.bbf08cp+1
+0x1.cc291ap+2
+0x1.1b29f4p+0
+0x1.55f758p-3
+0x1.3d782p+0
+0x1.03f4a8p-2
+0x1.d9306ep+1
+0x1.c5b27p+2
+0x1.71038ep+1
+0x1.0b807ap+1
+0x1.3c78bcp+2
+0x1.c7c18cp-2
+0x1.5e51ap-5
+0x1.3840ecp+2
+0x1.186b0ap+3
+0x1.c05d14p+2
+0x1.3bb9dap+3
+0x1.60b3d8p+0
+0x1.def62ep-1
+0x1.f1662cp+2
+0x1.e81886p+2
+0x1.ea4e8p+2
+0x1.46962cp+2
+0x1.378b82p+1
+0x1.b6781ap+2
+0x1.5df9fp+2
+0x1.aaaedep+0
+0x1.c218e8p+0
+0x1.54ccfap-1
+0x1.bac0f6p+2
+0x1.24fe86p+2
+0x1.0ab8eap+3
+0x1.3d2354p+1
+0x1.d24432p+2
+0x1.7c11acp+2
+0x1.b388a8p+0
+0x1.37aebep+3
+0x1.266718p+3
+0x1.2dfffp+1
+0x1.e8888p-3
+0x1.e65914p+2
+0x1.19f262p+0
+0x1.654a26p-1
+0x1.50b842p+2
+0x1.2593e2p+3
+0x1.5f03dap+0
+0x1.7e6ce6p-1
+0x1.7b586ep+2
+0x1.5b3c2ap+1
+0x1.f79258p+2
+0x1.3bb144p+3
+0x1.ef130ap+1
+0x1.4e1716p+2
+0x1.282f32p+1
+0x1.8ad63cp-1
+0x1.203b48p+0
+0x1.15792ep+0
+0x1.142f1cp+3
+0x1.4a78c8p+2
+0x1.cf512cp+2
+0x1.66676ep+2
+0x1.78b578p+1
+0x1.c37fd6p+2
+0x1.1cc856p+3
+0x1.bc687p+2
+0x1.a9faacp+2
+0x1.93c39ep+1
+0x1.6a9cdep-2
+0x1.32166cp+3
+0x1.9aa5bep+2
+0x1.1413f2p+3
+0x1.3835bp+3
+0x1.221712p+2
+0x1.39d4d4p+3
+0x1.a58c9p+0
+0x1.a286dcp+2
+0x1.aa22b8p+2
+0x1.019798p+2
+0x1.7f7a38p+0
+0x1.f214bp-2
+0x1.f783ap-1
+0x1.2ccdb2p+3
+0x1.84de98p+2
+0x1.4d986ep-2
+0x1.7649cap+2
+0x1.cb9d9cp+0
+0x1.1a7c98p+1
+0x1.e7ccbp+0
+0x1.498d8ap+1
+0x1.147658p+3
+0x1.f5ea62p-2
+0x1.cc8acep+1
+0x1.5b156ap+2
+0x1.8924dap+2
+0x1.b4cd22p+2
+0x1.3b8dfep+3
+0x1.e1931cp+0
+0x1.878c5p+2
+0x1.402bdap+3
+0x1.c8e57ep+1
+0x1.2a4f3cp+3
+0x1.9db45ap+1
+0x1.12abbcp+3
+0x1.2c7428p+2
+0x1.ad05f2p+2
+0x1.08c982p+3
+0x1.9095d6p+0
+0x1.e9422p+2
+0x1.441258p+0
+0x1.63520cp+0
+0x1.e45aep+0
+0x1.eb6082p+2
+0x1.2a725ep+2
+0x1.3b792ap+1
+0x1.3ca84cp+3
+0x1.fe20d6p+2
+0x1.308158p+1
+0x1.df5964p+2
+0x1.889264p+1
+0x1.1718bp+3
+0x1.a4dec2p+2
+0x1.17c632p+3
+0x1.393c4ep-1
+0x1.bc04ccp+2
+0x1.3f1162p+2
+0x1.13b302p+3
+0x1.e9ccbep+0
+0x1.986a3ep+1
+0x1.f27f08p+2
+0x1.0ab154p+2
+0x1.110c2p+3
+0x1.a842d2p+2
+0x1.191394p+2
+0x1.5eacbcp+2
+0x1.06c1cep+2
+0x1.0c8f04p-1
+0x1.08e7cp+3
+0x1.a3303p+1
+0x1.2e1514p+2
+0x1.07cb18p+1
+0x1.341c92p-1
+0x1.3514f4p+3
+0x1.1c93b4p-1
+0x1.39f878p+0
+0x1.ce87b2p+0
+0x1.421914p+1
+0x1.421486p+2
+0x1.592fd6p+2
+0x1.6353d4p-1
+0x1.2cdb74p+0
+0x1.62ce4ap+2
+0x1.8f37ecp+1
+0x1.af61e6p+2
+0x1.1d1a76p+2
+0x1.d23142p+2
+0x1.a838b8p+2
+0x1.04db92p+2
+0x1.1d069p+2
+0x1.bea8cep+2
+0x1.2d84e8p+2
+0x1.3e500ep+2
+0x1.54fb22p+0
+0x1.6435b8p+2
+0x1.3bd65p+3
+0x1.3013eep+3
+0x1.a4617p+2
+0x1.adcdd6p-1
+0x1.64a9ecp+1
+0x1.27912cp+3
+0x1.39e97ap-1
+0x1.211a7ap+3
+0x1.0620e2p+2
+0x1.97f504p+2
+0x1.7a9178p+2
+0x1.37f544p+3
+0x1.890b2ap+1
+0x1.288282p-2
+0x1.a4a298p-2
+0x1.af9172p+2
+0x1.7b02bcp+1
+0x1.eb1cc4p+2
+0x1.63f96p+2
+0x1.09782cp+3
+0x1.003912p+3
+0x1.f0660cp+2
+0x1.931464p+2
+0x1.ee1acp+0
+0x1.1262c8p+2